
#include <cstdio>
#include <vector>
#include <queue>
using namespace std;

#define flow(from, to) (f[from][to] - f[to][from])
#define residue(from, to) (g[from][to] - flow(from,to))
int maxflow(vector<vector<int> > &g, vector<vector<int> > &f,int s,int t){
	int n = g.size();
	int flow = 0;
	while(true){
		queue<int> q;
		vector<int> bpath(n,-1);
		bpath[s] = -2;
		q.push(s);
		while(!q.empty()){
			int p = q.front();
			q.pop();
			for(int i=0;i<n;i++)
				if(bpath[i] == -1 && residue(p,i) > 0){
					bpath[i] = p;
					q.push(i);
				}
		}
		if(bpath[t] == -1) return flow;
		int tau = 400000;
		for(int w=t,v=bpath[w];v>=0;w=v,v=bpath[w])
			tau = min(tau, residue(v,w));
		for(int w=t,v=bpath[w];v>=0;w=v,v=bpath[w])
			f[v][w] += tau;
		flow+= tau;
	}
}


int main(void){
	int n,f,d;
	scanf("%d %d %d", &n, &f, &d);
	int sz = 2+n+n+f+d;
	vector<vector<int> > graph,flow;
	graph = flow = vector<vector<int> >(sz,vector<int>(sz,0));
	int start = 0;
	int goal = f+n+n+d+1;
	for(int i=1;i<=f;i++)
		graph[start][i] = 1;
	for(int i=1;i<=d;i++)
		graph[f+n+n+i][goal] = 1;
	for(int i=1;i<=n;i++)
		graph[f+i][f+n+i] = 1;
	for(int i=1;i<=n;i++){
		int tf,td;
		scanf("%d %d", &tf, &td);
		for(int j=0;j<tf;j++){
			int t;
			scanf("%d", &t);
			graph[t][f+i] = 1;
		}
		for(int j=0;j<td;j++){
			int t;
			scanf("%d", &t);
			graph[f+n+i][f+n+n+t] = 1;
		}
	}
	printf("%d\n", maxflow(graph,flow,start,goal));
}
